using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Runtime.ExceptionServices;
using System.Security.Permissions;
using UnityEngine;
using UnityEngine.Events;

//Most of the code is taken from other mods so this is kind of a mess
// at least it works I guess
namespace Undertale
{
    public class Undertale
    {
        public static void Main()
        {
 CategoryBuilder.Create("UT", "Undertale Stuff", ModAPI.LoadSprite("category.png"));
 Liquid.Register("Dust", new doost());
 Liquid.Register("SpiderBlood", new bblood());
 Liquid.Register("Darkness", new blackliquid());
     //Sans
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Sans",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "BAD TIME",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("sansView.png"),
                    AfterSpawn = (Instance) =>
                    {
						
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("sansskin.png");
                        var flesh = ModAPI.LoadTexture("sansflesh.png");
                        var bone = ModAPI.LoadTexture("sansbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(108, 4, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(108, 36, 33); //second bruise colour. red by default
                        person.SetThirdBruiseColor(30, 30, 30); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(54, 21, 21); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );

//chara
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Chara",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "DETERMINATION",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("pplView2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("Charaskin.png");
                        var flesh = ModAPI.LoadTexture("Charaflesh.png");
                        var bone = ModAPI.LoadTexture("pplbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(77, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
						
                    }
                }
            );
//frisk
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Frisk",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "DETERMINATION",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("pplView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("friskskin.png");
                        var flesh = ModAPI.LoadTexture("friskflesh.png");
                        var bone = ModAPI.LoadTexture("pplbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(77, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
											
                    }
                }
            );
			//Undyne
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Undyne",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "Fish",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("UDV.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("UDskin.png");
                        var flesh = ModAPI.LoadTexture("UDflesh.png");
                        var bone = ModAPI.LoadTexture("UDbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(77, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
			//Undyne The Undying
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Undyne The Undying",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "Fish that never gives up",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("UUDV.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("UuDskin.png");
                        var flesh = ModAPI.LoadTexture("UuDflesh.png");
                        var bone = ModAPI.LoadTexture("UDbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(77, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
			//Asgore
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Asgore",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "Human...It was nice to meet you",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("aspic.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("asgoreskin.png");
                        var flesh = ModAPI.LoadTexture("as-gore.png");
                        var bone = ModAPI.LoadTexture("asbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(77, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
			
			//Muffet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Muffet",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "Spider Donut Maker",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("MuView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        var skin = ModAPI.LoadTexture("MuffetSkin.png");
                        var flesh = ModAPI.LoadTexture("MuffetFlesh.png");
                        var bone = ModAPI.LoadTexture("MuffetBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(0, 125, 150); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(0, 110, 160); //second bruise colour. red by default
                        person.SetThirdBruiseColor(0, 100, 255); // third bruise colour. light yellow by default
                        person.SetBloodColour(0,132,182); // blood clour. dark red by default
                        person.SetRottenColour(10, 98, 84); // rotten/zombie colour. light yellow/green by default
                
				foreach (LimbBehaviour limb in person.Limbs)
                      {
                         
                         limb.BloodLiquidType = "SpiderBlood";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("SpiderBlood"), 2f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      
                  }
              }
            );
			//toriel
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Toriel",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "Destroy The Child",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("torView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("torielskin.png");
                        var flesh = ModAPI.LoadTexture("toriflesh.png");
                        var bone = ModAPI.LoadTexture("toribone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(77, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
			//Papyrus
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Papyrus",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "Spagoot",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("pView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        var skin = ModAPI.LoadTexture("papskin.png");
                        var flesh = ModAPI.LoadTexture("papflesh.png");
                        var bone = ModAPI.LoadTexture("papbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(100, 100, 100); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(150, 150, 150); //second bruise colour. red by default
                        person.SetThirdBruiseColor(30, 30, 30); // third bruise colour. light yellow by default
                        person.SetBloodColour(250, 250, 250); // blood clour. dark red by default
                        person.SetRottenColour(200, 200, 200); // rotten/zombie colour. light yellow/green by default
					
						foreach (LimbBehaviour limb in person.Limbs)
                      {
                         
                         limb.BloodLiquidType = "Dust";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Dust"), 2f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      
                  }
              }
            );
			//Gaster
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Gaster",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "👌︎♏︎⬥︎♋︎❒︎♏︎ □︎♐︎ ⧫︎♒︎♏︎ ❍︎♋︎■︎ ⬥︎♒︎□︎ ⬧︎◻︎♏︎♋︎🙵⬧︎ ♓︎■︎ ♒︎♋︎■︎♎︎⬧︎📬︎",
                    ThumbnailOverride = ModAPI.LoadSprite("gasp.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        var skin = ModAPI.LoadTexture("Gaster.png");
                        var flesh = ModAPI.LoadTexture("Gasterflesh.png");
                        var bone = ModAPI.LoadTexture("Gasterbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(0, 0, 0); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(0, 0, 0); //second bruise colour. red by default
                        person.SetThirdBruiseColor(0, 0, 0); // third bruise colour. light yellow by default
                        person.SetBloodColour(0, 0, 0); // blood clour. dark red by default
                        person.SetRottenColour(200, 200, 200); // rotten/zombie colour. light yellow/green by default
					
						foreach (LimbBehaviour limb in person.Limbs)
                      {
                         
                         limb.BloodLiquidType = "Darkness";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Darkness"), 2f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      
                  }
              }
            );
			//Alphys
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "alphys",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "Anime is real",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("AlphysView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("alphysskin.png");
                        var flesh = ModAPI.LoadTexture("alphysflesh.png");
                        var bone = ModAPI.LoadTexture("alphysbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(77, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
			//Asriel
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Asriel",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "The Absolute GOD of Hyperdeath",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("asrView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("AsrSkin.png");
                        var flesh = ModAPI.LoadTexture("AsrFlesh.png");
                        var bone = ModAPI.LoadTexture("AsrBone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(108, 0, 4); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(77, 0, 3); //second bruise colour. red by default
                        person.SetThirdBruiseColor(37, 0, 1); // third bruise colour. light yellow by default
                        person.SetBloodColour(108, 0, 4); // blood clour. dark red by default
                        person.SetRottenColour(98, 98, 84); // rotten/zombie colour. light yellow/green by default
                    }
                }
            );
							
          //Flowey
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Gorse"),
                    NameOverride = "Flowey ",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "evil flower",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("flowey.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("flowskin.png");
                        var flesh = ModAPI.LoadTexture("flowflesh.png");
                        var bone = ModAPI.LoadTexture("flowbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                    }
                }
            );
    //Mettaton
	ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
			        NameOverride = "Mettaton", //new item name with a suffix to assure it is globally unique
					NameToOrderByOverride = "ZZ666",
			        DescriptionOverride = "Oh Yeah!", //new item description
			        CategoryOverride = ModAPI.FindCategory("UT"), //new item category
			        ThumbnailOverride = ModAPI.LoadSprite("Metta.png"), //new item thumbnail (relative path)
			        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
			        {
			            //load textures for each layer (see Human textures folder in this repository)
			            var skin = ModAPI.LoadTexture("metaskin.png");
			            var flesh = ModAPI.LoadTexture("metaf.png");
			            var bone = ModAPI.LoadTexture("metab.png");

			            //use the helper function to set each texture
			            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin,flesh,bone);
			        }
			    }
			);
			//Mettaton NEO
	ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Android"), //item to derive from
			        NameOverride = "Mettaton NEO", //new item name with a suffix to assure it is globally unique
					NameToOrderByOverride = "ZZ666",
			        DescriptionOverride = "Power of NEO", //new item description
			        CategoryOverride = ModAPI.FindCategory("UT"), //new item category
			        ThumbnailOverride = ModAPI.LoadSprite("MettaNeo.png"), //new item thumbnail (relative path)
			        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
			        {
			            //load textures for each layer (see Human textures folder in this repository)
			            var skin = ModAPI.LoadTexture("mettaneoskin.png");
			            var flesh = ModAPI.LoadTexture("metaf.png");
			            var bone = ModAPI.LoadTexture("metab.png");

			            //use the helper function to set each texture
			            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin,flesh,bone);
						 var backpack = new GameObject("Backpack");
                             backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                             backpack.transform.localPosition = new Vector3(-0.3f, 0f);
                             backpack.transform.localScale = new Vector3(1f, 1f);
                             var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                             backpackSprite.sprite = ModAPI.LoadSprite("NeoWings.png");
                             backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
			        }
			    }
			);
			
			//Real Knife
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),
                    NameOverride = "Real Knife",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "About time",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("realknife.png", 1f),
                    AfterSpawn = (generatorInstance) =>
                    {
                        generatorInstance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("realknife.png");
                    }
                }
            );
			//Toy Knife
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),
                    NameOverride = "Toy Knife",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "Surprisingly sharp",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("toyknife.png", 1f),
                    AfterSpawn = (generatorInstance) =>
                    {
                        generatorInstance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("toyknife.png");
                    }
                }
            );
//Gun
ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Revolver"),
    NameOverride = "Full Gun",
    DescriptionOverride = "No longer empty",
    CategoryOverride = ModAPI.FindCategory("UT"),
    NameToOrderByOverride = "2",
    ThumbnailOverride = ModAPI.LoadSprite("Ugun.png"),
    AfterSpawn = (Instance) =>
    {

        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Ugun.png");
        foreach (var c in Instance.GetComponents<Collider2D>())
        {
            GameObject.Destroy(c);
        }
        Instance.FixColliders();
        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

        var firearm = Instance.GetComponent<FirearmBehaviour>();
       
        Cartridge customCartridge = ModAPI.FindCartridge(".357");
        customCartridge.name = ".357";
        customCartridge.Damage *= 2.0f;
        customCartridge.StartSpeed *= 1.5f;
        customCartridge.PenetrationRandomAngleMultiplier *= 0.6f;
        customCartridge.Recoil *= 0.7f;
        customCartridge.ImpactForce *= 0.9f;
        firearm.Cartridge = customCartridge;

        Instance.FixColliders();
}
}
);
//burnt pan
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Burnt Pan",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = " ",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("bpan.png", 1f),
                    AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("bpan.png");
            Instance.FixColliders();
        }
    }
);

//Chaos Saber
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),
                    NameOverride = "Chaos Saber",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "Asriel's Sword",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("ChaosSaber.png", 1f),
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ChaosSaber.png");
						Instance.FixColliders();
                    }
                }
            );
			//Small blaster
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Blaster Rifle"),
                                NameOverride = "Gaster Blaster",
                                NameToOrderByOverride = "Z666",
                                DescriptionOverride = "bad time",
                                CategoryOverride = ModAPI.FindCategory("UT"),
                                ThumbnailOverride = ModAPI.LoadSprite("GasterBlaster.png", 5f),
                                AfterSpawn = (Instance) =>
                                {
                         /**/
                        
                        //get rid of yellow light thingy
						//Doesn't actually work 
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                          
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("GasterBlaster.png", 1.1f);
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    Instance.FixColliders();									
									
                                    {
                                      ModAPI.CreateParticleEffect("MetalHit", Instance.GetComponent<CanShoot>().BarrelPosition);                       
                                    }; 
                                }
                            }
                        );
                //Chaos Buster
                ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Archelix Caster"),
                                NameOverride = "Chaos Buster",
                                NameToOrderByOverride = "Z666",
                                DescriptionOverride = "Worse time",
                                CategoryOverride = ModAPI.FindCategory("UT"),
                                ThumbnailOverride = ModAPI.LoadSprite("ChaosBuster.png", 5f),
                                AfterSpawn = (Instance) =>
                                {
                                                   
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ChaosBuster.png", 1.1f);
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    Instance.FixColliders();									
									
                                    
                                }
                            }
                        );
						//Neo Gun
ModAPI.Register(
new Modification()
{
OriginalItem = ModAPI.FindSpawnable("Revolver"),
    NameOverride = "Mettaton NEO's arm cannon",
    DescriptionOverride = "No longer empty",
    CategoryOverride = ModAPI.FindCategory("UT"),
    NameToOrderByOverride = "2",
    ThumbnailOverride = ModAPI.LoadSprite("neoGun.png"),
    AfterSpawn = (Instance) =>
    {

        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("neoGun.png");
        foreach (var c in Instance.GetComponents<Collider2D>())
        {
            GameObject.Destroy(c);
        }
        Instance.FixColliders();
		Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
        Instance.GetComponent<FirearmBehaviour>().BulletsPerShot = 1;

        var firearm = Instance.GetComponent<FirearmBehaviour>();
       
        Cartridge customCartridge = ModAPI.FindCartridge("120 mm");
        customCartridge.name = "120 mm";
        customCartridge.Damage *= 1.0f;
        customCartridge.StartSpeed *= 1.5f;
        customCartridge.PenetrationRandomAngleMultiplier *= 0.6f;
        customCartridge.Recoil *= 0.2f;
        customCartridge.ImpactForce *= 1.0f;
        firearm.Cartridge = customCartridge;

        Instance.FixColliders();
}
}
);
		//big blaster
            ModAPI.Register(
                            new Modification()
                            {
                                OriginalItem = ModAPI.FindSpawnable("Accelerator"),
                                NameOverride = "Mega Gaster Blaster",
                                NameToOrderByOverride = "Z666",
                                DescriptionOverride = "worst time",
                                CategoryOverride = ModAPI.FindCategory("UT"),
                                ThumbnailOverride = ModAPI.LoadSprite("MegaGasterBlaster.png", 5f),
                                AfterSpawn = (Instance) =>
                                {       
                          
                                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MegaGasterBlaster.png", 1.1f);
                                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                                    Instance.FixColliders();									
									
                                    {
                                      ModAPI.CreateParticleEffect("MetalHit", Instance.GetComponent<CanShoot>().BarrelPosition);                       
                                    }; 
                                }
                            }
                        );

						
						//Undyne Spear
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Spear"),
                    NameOverride = "Udyne's Spear",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    DescriptionOverride = "NGAAAAAHHHHHHHH",
                    ThumbnailOverride = ModAPI.LoadSprite("UDSpear.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("UDSpear.png");
						Instance.FixColliders();
                    }
                }
            );
			//Asgore Trident
            ModAPI.Register(
    new Modification()
    {  
        OriginalItem = ModAPI.FindSpawnable("Spear"),
        NameOverride = "Asgore's Trident",
        NameToOrderByOverride = "ZZ666",
        DescriptionOverride = "Goodbye.", 
        CategoryOverride = ModAPI.FindCategory("UT"),
        ThumbnailOverride = ModAPI.LoadSprite("trip.png"),
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("aTrident.png"); //get the SpriteRenderer and replace its sprite with a custom one
            Instance.FixColliders();
        }
    }
);
//Dog
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "Dog",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "*dogsong starts playing",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("Adog.png", 1f),
                    AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Adog.png");
            Instance.FixColliders();
        }
    }
);
//Metaton_bot
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Mettaton Initial Form",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "I'M NOT GOING TO DESTROY YOU WITHOUT A LIVE TELEVISION AUDIENCE!!",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("MetaI.png", 1f),
                    AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MetaI.png");
            Instance.FixColliders();
        }
    }
);

//Bone
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow Bolt"), 
                    NameOverride = "Bone", // Name.
                    NameToOrderByOverride = "ZZ666", //  
                    DescriptionOverride = "A sharp bone",// Description
                    CategoryOverride = ModAPI.FindCategory("UT"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("bone.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("bone.png", 1f);
 
                    }
                }
            );

 //Bone gun
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Bone Launcher",
                    NameToOrderByOverride = "ZZ666",
                    DescriptionOverride = "Big bone that fires smaller bones",
                    CategoryOverride = ModAPI.FindCategory("UT"),
                    ThumbnailOverride = ModAPI.LoadSprite("bonelauncher.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("bonelauncher.png", 1.5f);
                        Instance.GetComponent<SpriteRenderer>().sortingOrder = 10;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("Bone");
 
                    }
                }
            );

        }
    }
}
public class doost : Liquid
{
    public doost()
    {
        this.Color = new Color32(255, 255, 255, 100);
    }

    public override void OnEnterContainer(BloodContainer container)
    {
    }

    public override void OnEnterLimb(LimbBehaviour limb)
    {
        if (limb.SpeciesIdentity == "Android" && UnityEngine.Random.value > 0.995f)
        {
            limb.PhysicalBehaviour.Charge += 0.1f;
        }
    }

    public override void OnExitContainer(BloodContainer container)
    {
    }

    public const string ID = "Dust";
}
public class bblood : Liquid
{
    public bblood()
    {
        this.Color = new Color32(0, 132, 190, 255);
    }

    public override void OnEnterContainer(BloodContainer container)
    {
    }

    public override void OnEnterLimb(LimbBehaviour limb)
    {
        if (limb.SpeciesIdentity == "Android" && UnityEngine.Random.value > 0.995f)
        {
            limb.PhysicalBehaviour.Charge += 0.1f;
        }
    }

    public override void OnExitContainer(BloodContainer container)
    {
    }

    public const string ID = "Darkness";
}
public class blackliquid : Liquid
{
    public blackliquid()
    {
        this.Color = new Color32(0, 0, 0, 255);
    }

    public override void OnEnterContainer(BloodContainer container)
    {
    }

    public override void OnEnterLimb(LimbBehaviour limb)
    {
        if (limb.SpeciesIdentity == "Android" && UnityEngine.Random.value > 0.995f)
        {
            limb.PhysicalBehaviour.Charge += 0.1f;
        }
    }

    public override void OnExitContainer(BloodContainer container)
    {
    }

    public const string ID = "Darkness";
}